<?php
/*
Plugin Name:	Facebook Post Planner - Wordpress Plugin
Plugin URI: 	http://codecanyon.net/user/Web-Wizards
Description: 	Facebook Post Planner - Wordpress Plugin - This plugin allows you to post automatically post/pages from your wordpress website to your facebook profile/page/group.
Version: 		1.0
Author: 		Web-Wizards
*/

// Plugin facebook SDK load
require_once ( WP_PLANNER_DIR . 'lib/scripts/facebook/facebook.php' );

/*
	Version: 	1.0.0
	Author: 	Web-Wizards
*/
class fbPlannerUtils
{
    // Hold an instance of the class
    private static $instance;
	
	// Hold an utils of the class
    private static $utils;
	
    private static $fb;
 
    // The singleton method getInstance
    public static function getInstance()
    {
        if (!isset(self::$instance)) {
            self::$instance = new fbPlannerUtils;
        }
        return self::$instance;
    }
	
	// The constructor, call on class instance
	public function __construct(){
	
		// tmp string
		$wplannerfb_settings = get_option( 'wplannerfb' );
		
		// create utils
		self::$utils = array(
			'token'		=> get_option('wplanner_token'),
			'appId'		=> $wplannerfb_settings['app_id'],
			'secret'	=> $wplannerfb_settings['app_secret'],
			'inputs_available' => $wplannerfb_settings['inputs_available']
		);
		
		// try to login on fb with static facebook key
		if(!$this->fb_login()){
			die('Invalid FB login!');
		}
	}
	
	public function fb_login() {
		// Create our Application instance (replace this with your appId and secret).
		self::$fb = new wwPP_Facebook(array(
			'appId'  => self::$utils['appId'],
			'secret' => self::$utils['secret'],
		));
		
		// set saved access token
		self::$fb->setAccessToken(self::$utils['token']);
		
		// Get User ID
		$user = self::$fb->getUser();
		if(trim($user) == ""){
			return false;
		}
		
		return true;
	}
	
	public function getFbUserData() {
		if($this->fb_login()){
			return self::$fb->api('/me');
		}else{
			return array();
		}
	}
	
	public function publishToWall($id, $whereToPost, $postPrivacy, $postData = NULL) {
		// retrive WP post metadata
		if( is_null($postData) ) {
			$postData = $this->getPostByID($id);
		}
		
		// where to publish post
		$whereToPost = unserialize($whereToPost);
		
		if(trim($whereToPost['profile']) == '' && trim($whereToPost['page_group']) == '')
			return false;
			
		if(count($postData) > 0) {
			try {
				$post_link = trim($postData['link']) == 'post_link' ? get_permalink($id) : $postData['link'];
				
				if($postPrivacy == 'CUSTOM') {
					$q_postPrivacy = array('value' => $postPrivacy, 'friends' => 'SELF');
				}else{
					$q_postPrivacy = array('value' => $postPrivacy);
				}
				
				if( trim($whereToPost['profile']) == 'on' ) {
					$statusUpdate = self::$fb->api(
						'/me/feed', 
						'post',
						array(
							'name' 			=> stripslashes($postData['name']),
							'message' 		=> self::$utils['inputs_available']['message'] == '1' ? stripslashes($postData['message']) : '',
							'privacy' 		=> $q_postPrivacy,
							'description' 	=> substr(stripslashes($postData['description']), 0, 10000),
							'picture'	 	=> self::$utils['inputs_available']['image'] == '1' ? $postData['picture'] : '',
							'caption'		=> self::$utils['inputs_available']['caption'] == '1' ? stripslashes($postData['caption']) : '',
							'link'			=> $post_link
						)
					);
				}
				
				if( isset($whereToPost['page_group']) && trim($whereToPost['page_group']) != '' ) {
					$args = array(
						'name' 			=> stripslashes($postData['name']),
						'message' 		=> self::$utils['inputs_available']['message'] == '1' ? stripslashes($postData['message']) : '',
						'description' 	=> substr(stripslashes($postData['description']), 0, 10000),
						'picture'	 	=> self::$utils['inputs_available']['image'] == '1' ? stripslashes($postData['picture']) : '',
						'caption'		=> self::$utils['inputs_available']['caption'] == '1' ? stripslashes($postData['caption']) : '',
						'link'			=> $post_link
					);
					
					$page_access_token = null;
					$whereToPost = explode('##', $whereToPost['page_group']);
					$postTo_ident = $whereToPost[0];
					$postTo_id = $whereToPost[1];
					
					if($postTo_ident == 'page') {
						$page_access_token = $whereToPost[2];
						
						if( !empty($page_access_token) ) {
							$args['access_token'] = $page_access_token;
						}
					}
					
					$statusUpdate = self::$fb->api(
						'/' . $postTo_id . '/feed', 
						'post',
						$args
					);
				}
				
				return true;
			} catch (wwPP_FacebookApiException $e) {
				var_dump('<pre>',$e ,'</pre>'); die; 
				return false;
			}
		}
	}
	
	public function getPostByID($id){
		if((int)$id > 0){
			return array(
				'name' 			=> get_post_meta($id, '_wplannerfb_title', true),
				'link' 			=> get_post_meta($id, '_wplannerfb_permalink', true),
				'description' 	=> get_post_meta($id, '_wplannerfb_description', true),
				'caption' 		=> get_post_meta($id, '_wplannerfb_caption', true),
				'message' 		=> get_post_meta($id, '_wplannerfb_message', true),
				'picture'	 	=> get_post_meta($id, '_wplannerfb_image', true)
			);
		}
		return array();
	}
}